<?php

declare(strict_types = 1);

/**
 * Copyright (C) 2025 PRONOVIX GROUP.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
 * USA.
 */

namespace Drupal\recipe_code_installer\Infrastructure\ProjectRootPathResolver;

use Composer\InstalledVersions;
use Drupal\recipe_code_installer\Application\Port\ProjectRootPathResolverInterface;

/**
 * Resolves project specific root path using Composer Runtime API.
 *
 * @internal This class is not part of the module's public programming API.
 */
final class ResolveProjectsRootPathByComposerRuntimeApi implements ProjectRootPathResolverInterface {

  /**
   * {@inheritdoc}
   */
  public function getProjectRootPath(): string {
    // @phpstan-ignore return.type
    return realpath(InstalledVersions::getRootPackage()['install_path']);
  }

}
